/*
 * pci5992.h -- definitions 
 *
 * Copyright (C) 2005 CCLRC
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */
#ifndef _PCI5992_H_
#define _PCI5992_H_


#define PCI_VENDOR_ID_PCI5992  0x1196
#define PCI_DEVICE_ID_PCI5992  0x5992

#ifndef PCI5992_MAJOR
#define PCI5992_MAJOR 0
#endif


/* function prototypes */
static int pci5992_open(struct inode*, struct file*);
static int pci5992_release(struct inode*, struct file*);
static int pci5992_ioctl(struct inode*, struct file*, unsigned int, unsigned long);

static int pci5992_read_procmem(char *, char **, off_t, int, int *, void *);

static int pci5992_init_board(struct pci_dev *, const struct pci_device_id *);
static void pci5992_remove_board(struct pci_dev *);


#define PCI5992 "pci5992: "

uint32_t debug_level =0;
#define DPRINTF(x...)  if (debug_level != 0) printk(KERN_NOTICE "PCI5992: "x)


/*    PCI 5992 registers  -  these are all offsets from  the address in badr1_iobase    */

#define PCI5992_STATUS        0x00
#define PCI5992_LAMMASK       0x04
#define PCI5992_LAMSTATUS     0x0c
#define PCI5992_SERIALSTATUS  0x10
#define PCI5992_CNAF          0x14
#define PCI5992_DATA          0x18
#define PCI5992_DMD_STATUS    0x24


/*    IOCTL codes   */

#define DEFINE_CNAF   1
#define DEFINE_DATA   2
#define ACQUIRE_DATA  3
#define ACQUIRE_QX    4
#define EXECUTE       5
#define ACQUIRE_LAMSTATUS 6
#define ACQUIRE_SERIALSTATUS 7
#define ACQUIRE_OPERATIONSTATUS 8

#define TIMEOUT 10000       // time waiting for CAMAC cycle to complete




#endif /* _PCI5992_H_ */
